{% extends "templates/base.html" %}
{% set active_page = "history" %}
{% block body %}
  <h3>Previous and current runs <span id="count"></span></h1>
    <label>Show only today's runs <input type="checkbox" id="filter-today"/></label>
    <label>with status <select class="ice-cream" id="filter-status">
        <option value="">&#x00a4;</option>
        <option value="failed">Failed</option>
        <option value="succeeded">Succeded</option>
        <option value="running">Running</option>
      </select></label>

  <div id="container"></div>
  <script>
      let state = {ordCol: 'd', ordDesc: true, data: [],
                   filter_status: "", filter_today: false};

      function updateRun(data) {
        for(let i=0; i<state.data.length; ++i) {
          if (state.data[i].rid === data.rid) {
            state.data[i].st = data.st;
            break;
          }
        }
        view(state);
      }
      document.addEventListener("DOMContentLoaded", function() {
  
      fetch('/history.json')
      .then(function(response) {
          return response.json();
      })
      .then(function(js) {
          state.data = js.data;
          view(state);
      });

      document.getElementById('filter-status').addEventListener('change', function(e){
        state.filter_status = e.srcElement.value;
        view(state);
      });
      document.getElementById('filter-today').addEventListener('change', function(e){
        state.filter_today = e.srcElement.checked;
        view(state);
      });
  
  
      });
  
      function sortRuns(state) {
          return state.data.sort(function(a, b) {
              let fa = a[state.ordCol];
              let fb = b[state.ordCol];
              if (fa === fb)
                  return 0;
              let res = fa < fb;
              if (state.ordDesc)
                  res = !res;
              return res ? 1 : -1;
          });
      }
  
      function ce(name, inner, atts) {
          atts = atts || {};
          inner = inner || '';
          let elem = document.createElement(name);
          for (let k in atts) {
              elem.setAttribute(k, atts[k]);
          }
          elem.innerText = inner;
          return elem;
      }
      
      function runIsFinished(run) {
          return run.st === 'failed' || run.st === 'succeeded';
      }
  
      function sortOnCol(event) {
          let elem = event.target;
          if (!elem.dataset.col)
              return;
          let newOrdCol = elem.dataset.col;
          if (state.ordCol === newOrdCol) {
              state.ordDesc = !state.ordDesc;
          }
          else {
              state.ordCol = newOrdCol;
          }
          view(state);
      }
  
      function view(state) {
          state.data = sortRuns(state);
          const container = document.getElementById('container');
          container.innerHTML = '';
  
          let table = ce('table', '', {'class': 'uk-table uk-table-small uk-table-middle uk-table-justify uk-table-divider uk-table-hover'});
          container.appendChild(table);
          
          let thead = ce('thead');
          table.appendChild(thead);
          let tr = ce('tr', '', {'class': 'uk-text-bold'});
          thead.appendChild(tr);
          let cols = {'rid': 'Run Id', 'st': 'Status', 'd': 'Started on'};
          for (let f in cols) {
              let e = ce('th', cols[f], {'data-col': f});
              e.onclick = sortOnCol; 
              if (f === state.ordCol) {
                  e.appendChild(ce('span', '', {'uk-icon': state.ordDesc ? 'chevron-up' : 'chevron-down'}));
              }
              tr.appendChild(e);
          }
          tr.appendChild(ce('th', 'Description'));
          tr.appendChild(ce('th', 'Monitoring?'));
  
          let tbody = ce('tbody');
          table.appendChild(tbody);
  
          const colors = {'succeeded': 'uk-text-success',
                          'failed': 'uk-text-warning'}
          let count = 0;
          state.data.forEach(function (run) {
              if (state.filter_status != "" && run.st != state.filter_status)
                return;
              if (state.filter_today && (new Date).toISOString().substr(0, 10) !== 
                  run.d.substr(0, 10))
                return;
              count++;
              let row = ce('tr', '', {'data-rid': run.runid, 
                                      'class': colors[run.st] || ''});
              row.appendChild(ce('td', run.rid, {'class': 'uk-text-small'}));
              row.appendChild(ce('td', run.st));
              row.appendChild(ce('td', run.d, {'class': 'uk-text-small'}));
              row.appendChild(ce('td', run.description));
  
              row.addEventListener("dblclick", function(event) {
                event.preventDefault();
                fetch("/run/"+run.rid)
                  .then(function(response) {
                      return response.json();
                  })
                  .then(function(js) {
                    let modal = document.getElementById('run-details');
                    document.getElementById('details-run-id').innerText = js.rid;
                    // document.getElementById('details-run-ins').innerText = js.ins;
                    var ins = jsyaml.safeLoad(js.ins);
                    let insDiv = document.getElementById('details-run-ins');
                    insDiv.innerHTML='';
                    insDiv.appendChild(ce('h4', 'Inputs'));
                    let ul = insDiv.appendChild(ce('ul'));
                    for (let name in ins) {
                      let out = ins[name];
                      let c = typeof(out) === 'object' ? 
                        ce('a', name, {href: out['path']}) :
                        ce('span', name + " : " + out);
                      ul.appendChild(ce('li')).appendChild(c);
                    }

                    if (js.outs !== null) {
                      let outs = JSON.parse(js.outs);
                      let outsDiv = document.getElementById('details-run-outs');
                      outsDiv.innerHTML='';
                      outsDiv.appendChild(ce('h4', 'Outputs'));
                      let ul = outsDiv.appendChild(ce('ul'));
                      for (let name in outs) {
                        let out = outs[name];
                        let c = ce('a', name, {href: out['location']});
                        ul.appendChild(ce('li')).appendChild(c);
                      }
                    }
                      // document.getElementById('details-run-outs').innerText = js.outs;

                    UIkit.modal(modal).show();
                  });
                return false;
              });

              if (runIsFinished(run)) {
                  row.appendChild(ce('span'));
              }
              else {
                  row.appendChild(run.m ? ce('div', '', {'uk-spinner': 1}) :
                  ce('input', '', {'type': 'checkbox'}));
              }
              tbody.appendChild(row);
          });
          document.getElementById('count').innerText = "(" + count + ")";
      }
  </script>
  
<!-- This is the modal -->
<div id="run-details" uk-modal>
  <div class="uk-modal-dialog">
    <button class="uk-modal-close-default" type="button" uk-close></button>
    <div class="uk-modal-header">
        <h3 class="uk-modal-title">Run <span id="details-run-id"></span></h2>
    </div>
    <div class="uk-modal-body"></div>
    <div id="details-run-ins"></div>
    <div id="details-run-outs"></div>
    <div class="uk-modal-footer uk-text-right">
        <button class="uk-button uk-button-primary uk-modal-close" type="button">Dismiss</button>
    </div>
</div>
</div>

{% endblock %}